



# We do random-x sampling as it is not reasonable to assume
# fixed x as is required for fixed-x sampling



###################
# Szenario Trees
###################
  #index von all auf die die in intervalEstTree verwendet wurden  
  indexAll2reg<-all.design$token %in% all.design$token[-intervalEstTree$na.action]
  
   obsTree<- table(indexAll2reg)["TRUE"]
   
    allTokenReg<-all.design$token[!all.design$token%in%all.design[intervalEstTree$na.action, "token"]]
  
    boot.WTP.Tree<-function(data, 
                   indices 
                   ){
        data             <-  data[indices,] # this should be the weights
    intervalEstTreeBoot  <- survreg(equTree_interval, 
                           data = data,
                           dist = "gaussian", 
                            model=TRUE)
    
   newdata<-intervalEstTreeBoot$model
   newdata$leveltrees<-10
   newdata$leveltrees<-as.factor(newdata$leveltrees)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictTrees10  <-predict(intervalEstTreeBoot, newdata=newdata)
   
   # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictTrees10<all.design[indexAll2reg,"WTPl_tree"]&predictTrees10>0
   predictTrees10[index.temp] <-(all.design[indexAll2reg, "WTPl_tree"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictTrees10>all.design[indexAll2reg,"WTPu_tree"]&predictTrees10>0
   predictTrees10[index.temp] <-(all.design[indexAll2reg, "WTPu_tree"])[index.temp] 
   
  
   newdata<-intervalEstTreeBoot$model
   newdata$leveltrees<-50
   newdata$leveltrees<-as.factor(newdata$leveltrees)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictTrees50  <-predict(intervalEstTreeBoot, newdata=newdata)

   
   # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictTrees50<all.design[indexAll2reg,"WTPl_tree"]&predictTrees50>0
   predictTrees50[index.temp] <-(all.design[indexAll2reg, "WTPl_tree"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictTrees50>all.design[indexAll2reg,"WTPu_tree"]&predictTrees50>0
   predictTrees50[index.temp] <-(all.design[indexAll2reg, "WTPu_tree"])[index.temp] 
 
   
   
   return( 
     c("T10"=mean(predictTrees10), "T50"= mean(predictTrees50))
     )
    }


 set.seed(12345)

   boot.Tree<- boot(data=all.design[indexAll2reg,], 
     statistic=boot.WTP.Tree, 
     R=1000, 
     sim = "ordinary" , 
     stype = c("i"), # indices must thus be weights # c("i", "f", "w")
     strata = all.design[indexAll2reg,"stratum"] ,
     weights = if(useWeights){weights(uhi.raked_tree)[uhi.raked_tree$variables$token %in% allTokenReg]} #, 
     )

   boot.Tree

###################
# Szenario Fountains
###################
  #index von all auf die die in intervalEstTree verwendet wurden  
  indexAll2reg<-all.design$token %in% all.design$token[-intervalEstFoun$na.action]

 obsFoun<- table(indexAll2reg)["TRUE"]

  allTokenReg<-all.design$token[!all.design$token%in%all.design[intervalEstFoun$na.action, "token"]]
  
    boot.WTP.Foun<-function(data, 
                   indices 
                   ){
        data                <-  data[indices,] # this should be the weights
    intervalEstFounBoot  <- survreg(equFoun_interval, 
                           data = data,
                           dist = "gaussian", 
                            model=TRUE)
    
   newdata<-intervalEstFounBoot$model
   newdata$levelfoun <- "um die Hälfte erhöht"
   newdata$levelfoun<-as.factor(newdata$levelfoun)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictFoun50  <-predict(intervalEstFounBoot , newdata=newdata)

   # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictFoun50<all.design[indexAll2reg,"WTPl_foun"]&predictFoun50>0
   predictFoun50[index.temp] <-(all.design[indexAll2reg, "WTPl_foun"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictFoun50>all.design[indexAll2reg,"WTPu_foun"]&predictFoun50>0
   predictFoun50[index.temp] <-(all.design[indexAll2reg, "WTPu_foun"])[index.temp] 
   
   
   
   newdata<-intervalEstFounBoot$model
   newdata$levelfoun <- "verdoppelt"
   newdata$levelfoun<-as.factor(newdata$levelfoun)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictFoun100  <-predict(intervalEstFounBoot , newdata=newdata)
 
  # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictFoun100<all.design[indexAll2reg,"WTPl_foun"]&predictFoun100>0
   predictFoun100[index.temp] <-(all.design[indexAll2reg, "WTPl_foun"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictFoun100>all.design[indexAll2reg,"WTPu_foun"]&predictFoun100>0
   predictFoun100[index.temp] <-(all.design[indexAll2reg, "WTPu_foun"])[index.temp] 

   
   
   return( 
     c("F50"=mean(predictFoun50), "F100"= mean(predictFoun100))
     )
    }


 set.seed(12345)
   boot.Foun<- boot(data=all.design[indexAll2reg,], 
     statistic=boot.WTP.Foun, 
     R=1000, 
     sim = "ordinary" , 
     stype = c("i"), # indices must thus be weights # c("i", "f", "w")
     strata = all.design[indexAll2reg,"stratum"] ,
     weights =  if(useWeights){weights(uhi.raked_foun)[uhi.raked_foun$variables$token %in% allTokenReg]} #, 
     )

   boot.Foun

###################
# Szenario Both
###################
  #index von all auf die die in intervalEstTree verwendet wurden  
  indexAll2reg<-all.design$token %in% all.design$token[-intervalEstBoth$na.action]
 
   obsBoth<- table(indexAll2reg)["TRUE"]

   allTokenReg<-all.design$token[!all.design$token%in%all.design[intervalEstBoth$na.action, "token"]]

  
    boot.WTP.Both<-function(data, 
                   indices 
                   ){
        data             <-  data[indices,] # this should be the weights
    intervalEstBothBoot  <-  survreg(equBoth_interval, 
                               data = data,
                               dist = "gaussian", 
                               model=TRUE)

   newdata<-intervalEstBothBoot$model
   newdata$leveltrees <- 10
   newdata$leveltrees <- as.factor(newdata$leveltrees)
   newdata$levelfoun <- "um die Hälfte erhöht"
   newdata$levelfoun<-as.factor(newdata$levelfoun)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictBothT10F50  <-predict(intervalEstBothBoot , newdata=newdata)
   
   # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictBothT10F50<all.design[indexAll2reg,"WTPl_both"]&predictBothT10F50>0
   predictBothT10F50[index.temp] <-(all.design[indexAll2reg, "WTPl_both"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictBothT10F50>all.design[indexAll2reg,"WTPu_both"]&predictBothT10F50>0
   predictBothT10F50[index.temp] <-(all.design[indexAll2reg, "WTPu_both"])[index.temp] 

   

   newdata<-intervalEstBothBoot$model
   newdata$leveltrees <- 10
   newdata$leveltrees <- as.factor(newdata$leveltrees)
   newdata$levelfoun <- "verdoppelt"
   newdata$levelfoun<-as.factor(newdata$levelfoun)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictBothT10F100  <-predict(intervalEstBothBoot , newdata=newdata)
   
   # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictBothT10F100<all.design[indexAll2reg,"WTPl_both"]&predictBothT10F100>0
   predictBothT10F100[index.temp] <-(all.design[indexAll2reg, "WTPl_both"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictBothT10F100>all.design[indexAll2reg,"WTPu_both"]&predictBothT10F100>0
   predictBothT10F100[index.temp] <-(all.design[indexAll2reg, "WTPu_both"])[index.temp] 
   
   
   
      newdata<-intervalEstBothBoot$model
   newdata$leveltrees <- 50
   newdata$leveltrees <- as.factor(newdata$leveltrees)
   newdata$levelfoun <- "um die Hälfte erhöht"
   newdata$levelfoun<-as.factor(newdata$levelfoun)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictBothT50F50  <-predict(intervalEstBothBoot , newdata=newdata)

   # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictBothT50F50<all.design[indexAll2reg,"WTPl_both"]&predictBothT50F50>0
   predictBothT50F50[index.temp] <-(all.design[indexAll2reg, "WTPl_both"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictBothT50F50>all.design[indexAll2reg,"WTPu_both"]&predictBothT50F50>0
   predictBothT50F50[index.temp] <-(all.design[indexAll2reg, "WTPu_both"])[index.temp] 
   
   
   
   newdata<-intervalEstBothBoot$model
   newdata$leveltrees <- 50
   newdata$leveltrees <- as.factor(newdata$leveltrees)
   newdata$levelfoun <- "verdoppelt"
   newdata$levelfoun<-as.factor(newdata$levelfoun)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictBothT50F100  <-predict(intervalEstBothBoot , newdata=newdata)

   # modify prediction such that equal to lower level of interval if prediction is lower
   index.temp<-predictBothT50F100<all.design[indexAll2reg,"WTPl_both"]&predictBothT50F100>0
   predictBothT50F100[index.temp] <-(all.design[indexAll2reg, "WTPl_both"])[index.temp] 
   # modify prediction such that equal to higher level of interval if prediction is higher
   index.temp<-predictBothT50F100>all.design[indexAll2reg,"WTPu_both"]&predictBothT50F100>0
   predictBothT50F100[index.temp] <-(all.design[indexAll2reg, "WTPu_both"])[index.temp] 
    
   
   return( 
     c("T10F50"=mean(predictBothT10F50), "T10F100"= mean(predictBothT10F100), "T50F50"=mean(predictBothT50F50), "T50F100"= mean(predictBothT50F100))
     )
    }


 set.seed(12345)
  boot.Both<- boot(data=all.design[indexAll2reg,], 
     statistic=boot.WTP.Both, 
     R=1000, 
     sim = "ordinary" , 
     stype = c("i"), # indices must thus be weights # c("i", "f", "w")
     strata = all.design[indexAll2reg,"stratum"] ,
     weights = if(useWeights){weights(uhi.raked_both)[uhi.raked_both$variables$token %in% allTokenReg]} #, 
     )

   boot.Both

###################
# Szenario Joint
###################
  #index von all auf die die in intervalEstTree verwendet wurden  
  indexAll2reg<-all.design$token %in% all.design$token[ -intervalEstJoint$na.action]

 obsJoint<- table(indexAll2reg)["TRUE"]


   allTokenReg<-all.design$token[!all.design$token%in%all.design[intervalEstJoint$na.action, "token"]]
  
    boot.WTP.Joint<-function(data, 
                   indices 
                   ){
        data                <-  data[indices,] # this should be the weights
    intervalEstJointBoot  <- survreg(equJoint_interval, 
                           data = data,
                           dist = "gaussian", 
                            model=TRUE)
    
   newdata<-intervalEstJointBoot$model
   newdata$scenario <-"trees" #"trees"     "fountains" "both" 
   newdata$scenario<-as.factor(newdata$scenario)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictJointTr  <-predict(intervalEstJointBoot , newdata=newdata)

   #!! no modification of prediction such that equal to lower level of interval if prediction is lower
   # This is because we don't know of all observations in which interval the response was
   # This because we predict WTP e.g. WTP for trees for respondents which answered for fountains

  
   newdata<-intervalEstJointBoot$model
   newdata$scenario <-"fountains" #"trees"     "fountains" "both" 
   newdata$scenario<-as.factor(newdata$scenario)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictJointFo  <-predict(intervalEstJointBoot , newdata=newdata)
   
   
   newdata<-intervalEstJointBoot$model
   newdata$scenario <-"both" #"trees"     "fountains" "both" 
   newdata$scenario<-as.factor(newdata$scenario)
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_OthersUtility)")]<-"X10_debrief_joint_OthersUtility"
   names(newdata)[which(names(newdata)=="as.numeric(X10_debrief_joint_FavourHeatmeasures)")]<-"X10_debrief_joint_FavourHeatmeasures"
   names(newdata)[which(names(newdata)=="cluster(zgb)")]<-"zgb"
   predictJointBo  <-predict(intervalEstJointBoot , newdata=newdata)
   
   return( 
     c("Tr"=mean(predictJointTr), "Fo"= mean(predictJointFo), "Bo"= mean(predictJointBo))
     )
    }


 set.seed(12345)
   boot.Join<- boot(data=all.design[indexAll2reg,], 
     statistic=boot.WTP.Joint, 
     R=1000, 
     sim = "ordinary" , 
     stype = c("i"), # indices must thus be weights # c("i", "f", "w")
     strata = all.design[indexAll2reg,"stratum"] ,
     weights = if(useWeights){weights(uhi.raked_all)[uhi.raked_all$variables$token %in% allTokenReg]} #, 
     )

   boot.Join

