###############################
# 
#  Inteval Regression
#
################################### 



   #    a left censored observation where time of event < t: represented as (NA, t)
   #    a right censored observation where time of event >t: represented as (t, NA)
   #    an interval censored observations t1<=time <= t2   : represented as (t1,t2)

   eventTrees<-rep(3, nrow(all.design) )
   eventTrees[all.design$WTPu_tree ==0]<-2
   all.design$eventTrees<-eventTrees

   eventFount<-rep(3, nrow(all.design) )
   eventFount[all.design$WTPu_foun ==0]<-2
   all.design$eventFount<-eventFount

   eventBoth<-rep(3, nrow(all.design) )
   eventBoth[all.design$WTPu_both ==0] <-2
   all.design$eventBoth<-eventBoth

   eventJoint<-rep(3, nrow(all.design) )
   eventJoint[all.design$WTPu ==0]     <-2
   all.design$eventJoint<-eventJoint

   ##
   # setup the survival object with interval censoring
   #Trees
     (WTP_tree_interval <- with(all.design[], 
                           Surv(WTPl_tree, 
                                WTPu_tree, 
                                event = eventTrees, 
                                type = "interval")))
   # Fount
     (WTP_foun_interval <- with(all.design[], 
                           Surv(WTPl_foun, 
                                WTPu_foun, 
                                event = eventFount, 
                                type = "interval")))
   #Both
      (WTP_both_interval <- with(all.design[], 
                           Surv(WTPl_both, 
                                WTPu_both, 
                                event = eventBoth, 
                                type = "interval")))
   # Joint
       (WTP_join_interval <- with(all.design[], 
                           Surv(WTPl, 
                                WTPu, 
                                event = eventJoint, 
                                type = "interval")))

     # set here if st. errors for interval estimation should be
     # robust. 
       standarderrorsROBUST<-TRUE #FALSE

     equTree_interval <-as.formula(#WTP_tree_interval~ 
                        Surv(WTPl_tree[], WTPu_tree[], event = eventTrees[], type = "interval")~
                       leveltrees+
                       #levelfoun+
                       #levelboth+   
                       #block_trees+
                       #block_tree_m2+
                       treeDensityClasses+          
                       #X7_fees_vienna+
                       #ehrenamt+
                       #hh_persons+
                       hh_persons2Binary+
                       hh_persons3Binary+
                       #unter16+
                       #hh_grownups+
                       #einkommensbezieher+
                       #hitzeschutz+
                       #beruf_7+ # Pensionist         
                       #as.numeric(X10_debrief_joint_QuestionUnderstandable) +
                       #as.numeric(X10_debrief_joint_OwnUtility)+
                       as.numeric(X10_debrief_joint_OthersUtility)+
                       as.numeric(X10_debrief_joint_FavourHeatmeasures)+
                       #as.numeric(X10_debrief_joint_TreesAppropriate)+
                       #as.numeric(X10_debrief_joint_MoreTreesLessCarprakGood)+
                       #as.numeric(X10_debrief_joint_TreesPosImpactCity)+
                       #as.numeric(X10_debrief_joint_DontNeedMoreTreesMyArea)+
                       #as.numeric(X10_debrief_joint_DontNeedMoreTreesVienna)+
                       #as.numeric(X10_debrief_joint_FountainsHelpBearHeat)+
                       #as.numeric(X10_debrief_joint_EnoughFountainsVienna)+
                       gender+
                       age+
                       pension+
                       #I(age^2)+
                       #dogs+
                       #education2+
                       universitydegree+
                       dogOwn+
                       #as.factor(education2)+
                       #hitzeschutz+
                       #person_income+
                       #personal_incom_cont1000+
                       #contact_info+
                       #hh_income+
                       #hh_incom_cont1000 +
                       hh_incom_aequi+
                       #einkommensbezieher+
                       #as.factor(expect_income)+
                       parkpl+
                       car+
                       cluster(zgb)+
                       #carTwoormore
                       #carNoPark
                       #carAtleastone#+
                       #carspace+
                       online
                       #days
                       #as.factor(block_blockno)+
                       #block_density
                     #stratum 
               ) 


        # we use personal_income because
        # * personal income is highly correlated with 
        # hh_income: summary(lm(all.design$hh_incom_cont~all.design$personal_incom_cont))
        # * mean personal income is available at least on district level

          intervalEstTree <- survreg(equTree_interval,                            
                           data = all.design,#[all.design$token %in% uhi.raked_tree$variables$token& all.design$scenario=="trees" ,], 
                           dist = "gaussian", 
                           robust=standarderrorsROBUST, # TRUE results in an error in stargazer
                           #,weights=weights(all.design)
                           #,weights(uhi.raked_tree)
                          model=TRUE
                           )


          table5.Trees<-rbind(
           summary(intervalEstTree)$table,
           "Obs"=c(summary(intervalEstTree)$n,      NA, NA, NA,NA),
           "LogLik"=c(summary(intervalEstTree)$loglik[1], NA, NA, NA,NA)
           )[,c(1,2,5)]

           

### Fontain
                equFoun_interval <-as.formula(#WTP_foun_interval~ 
                              Surv(WTPl_foun, WTPu_foun, event = eventFount, type = "interval")~                                
                                #leveltrees+
                                 levelfoun+
                                #levelboth+   
                                #block_trees+
                                #block_tree_m2+
                                treeDensityClasses+          
                                #X4b_used_fountain+
                                #X7_fees_vienna+
                                #ehrenamt+
                                #hh_persons+
                                hh_persons2Binary+
                                hh_persons3Binary+
                                #unter16+
                                #hh_grownups+
                                #einkommensbezieher+
                                #hitzeschutz+
                                #beruf_7+ # Pensionist         
                                #as.numeric(X10_debrief_joint_QuestionUnderstandable) +
                                #as.numeric(X10_debrief_joint_OwnUtility)+
                                as.numeric(X10_debrief_joint_OthersUtility)+
                                as.numeric(X10_debrief_joint_FavourHeatmeasures)+
                                #as.numeric(X10_debrief_joint_TreesAppropriate)+
                                #as.numeric(X10_debrief_joint_MoreTreesLessCarprakGood)+
                                #as.numeric(X10_debrief_joint_TreesPosImpactCity)+
                                #as.numeric(X10_debrief_joint_DontNeedMoreTreesMyArea)+
                                #as.numeric(X10_debrief_joint_DontNeedMoreTreesVienna)+
                                #as.numeric(X10_debrief_joint_FountainsHelpBearHeat)+
                          #      as.numeric(X10_debrief_joint_EnoughFountainsVienna)+
                                gender+
                                age+
                                pension+
                                #I(age^2)+
                                #dogs+
                                #education2+
                                universitydegree+
                                dogOwn+
                                #as.factor(education2)+
                                #hitzeschutz+
                                #person_income+
                                #personal_incom_cont1000+
                                #contact_info+
                                #hh_income+
                                #hh_incom_cont1000 +
                                hh_incom_aequi+
                                #einkommensbezieher+
                                #expect_income+
                                car+
                                cluster(zgb)+
                                #carTwoormore
                                #carNoPark
                                #carAtleastone#+
                                #carspace+
                                online
                                #days
                                #as.factor(block_blockno)+
                                #block_density
                              #stratum 
                             ) 
                                     
       intervalEstFoun <- survreg(equFoun_interval, data = all.design, 
                           dist = "gaussian", 
                                robust=standarderrorsROBUST,
                           #,weights=weights(all)
                           model=TRUE
                        )

                      

          table5.Fount<-rbind(
           summary(intervalEstFoun)$table,
           "Obs"=c(summary(intervalEstFoun)$n,      NA, NA, NA,NA),
           "LogLik"=c(summary(intervalEstFoun)$loglik[1], NA, NA, NA,NA)
           )[,c(1,2,5)]

          
          


   #### Both
      equBoth_interval <-as.formula(#WTP_both_interval~ 
                             Surv(WTPl_both, WTPu_both, event = eventBoth,  type = "interval")~
                                leveltrees+
                                levelfoun+
                                #levelboth+   
                                #block_trees+
                                #block_tree_m2+
                                treeDensityClasses+          
                                #X4b_used_fountain+
                                #X7_fees_vienna+
                                #ehrenamt+
                                #hh_persons+
                                hh_persons2Binary+
                                hh_persons3Binary+
                                #unter16+
                                #hh_grownups+
                                #einkommensbezieher+
                                #hitzeschutz+
                                #beruf_7+ # Pensionist  
                                #as.numeric(X10_debrief_joint_QuestionUnderstandable) +
                                #as.numeric(X10_debrief_joint_OwnUtility)+
                                as.numeric(X10_debrief_joint_OthersUtility)+
                                as.numeric(X10_debrief_joint_FavourHeatmeasures)+
                                #as.numeric(X10_debrief_joint_TreesAppropriate)+
                                #as.numeric(X10_debrief_joint_MoreTreesLessCarprakGood)+
                                #as.numeric(X10_debrief_joint_TreesPosImpactCity)+
                                #as.numeric(X10_debrief_joint_DontNeedMoreTreesMyArea)+
                                #as.numeric(X10_debrief_joint_DontNeedMoreTreesVienna)+
                                #as.numeric(X10_debrief_joint_FountainsHelpBearHeat)+
                            #    as.numeric(X10_debrief_joint_EnoughFountainsVienna)+
                                gender+
                                age+
                                pension+
                                #I(age^2)+
                                #dogs+
                                #education2+
                                universitydegree+
                                dogOwn+
                                #as.factor(education2)+
                                #hitzeschutz+
                                #person_income+
                                #personal_incom_cont1000+
                                #contact_info+
                                #hh_income+
                                #hh_incom_cont1000 +
                                hh_incom_aequi+
                                #einkommensbezieher+
                                #expect_income+
                                parkpl+
                                car+
                                cluster(zgb)+
                                #carTwoormore
                                #carNoPark
                                #carAtleastone#+
                                #carspace+
                                online
                                #days+
                                #as.factor(block_blockno)+
                                #block_density
                              #stratum 
                                ) 
 
          intervalEstBoth <- survreg(equBoth_interval, data = all.design, 
                           dist = "gaussian", 
                           robust=standarderrorsROBUST,
                           #,weights=weights(all)
                           model=TRUE
                           )
        table5.Both<-rbind(
           summary(intervalEstBoth)$table,
           "Obs"=c(summary(intervalEstBoth)$n,      NA, NA, NA,NA),
           "LogLik"=c(summary(intervalEstBoth)$loglik[1], NA, NA, NA,NA)
           )[,c(1,2,5)]



 ####
 ## Joint

           equJoint_interval <-as.formula(#WTP_join_interval~ 
                             Surv(WTPl,      WTPu,      event = eventJoint, type = "interval")~
                                scenario+
                                #leveltrees+
                                #levelfoun+
                                #levelboth+   
                                #block_trees+
                                #block_tree_m2+
                                treeDensityClasses+          
                                #X4b_used_fountain+
                                #X7_fees_vienna+
                                #ehrenamt+
                                #hh_persons+
                                hh_persons2Binary+
                                hh_persons3Binary+
                                #unter16+
                                #hh_grownups+
                                #einkommensbezieher+
                                #hitzeschutz+
                                #beruf_7+ # Pensionist  
                                #as.numeric(X10_debrief_joint_QuestionUnderstandable) +
                                #as.numeric(X10_debrief_joint_OwnUtility)+
                                as.numeric(X10_debrief_joint_OthersUtility)+
                                as.numeric(X10_debrief_joint_FavourHeatmeasures)+
                                #as.numeric(X10_debrief_joint_TreesAppropriate)+
                                #as.numeric(X10_debrief_joint_MoreTreesLessCarprakGood)+
                                #as.numeric(X10_debrief_joint_TreesPosImpactCity)+
                                #as.numeric(X10_debrief_joint_DontNeedMoreTreesMyArea)+
                                #as.numeric(X10_debrief_joint_DontNeedMoreTreesVienna)+
                                #as.numeric(X10_debrief_joint_FountainsHelpBearHeat)+
                                #as.numeric(X10_debrief_joint_EnoughFountainsVienna)+
                                gender+
                                age+
                                pension+
                                #I(age^2)+
                                #dogs+
                                #education2+
                                universitydegree+
                                dogOwn+
                                #as.factor(education2)+
                                #hitzeschutz+
                                #person_income+
                                #personal_incom_cont1000+
                                #contact_info+
                                #hh_income+
                                #hh_incom_cont1000 +
                                hh_incom_aequi+
                                #einkommensbezieher+
                                #expect_income+
                                #parkpl+
                                car+
                                cluster(zgb)+
                                #carTwoormore
                                #carNoPark
                                #carAtleastone#+
                                #carspace+
                                online
                                #days+
                                #as.factor(block_blockno)+
                                #block_density
                              #stratum 
                             ) 


        intervalEstJoint <- survreg(equJoint_interval, data = all.design, 
                           dist = "gaussian", 
                           robust=standarderrorsROBUST,
                           #,weights=weights(all.design)
                           model=TRUE
                          )

        table5.Joint<-rbind(
           summary(intervalEstJoint)$table,
           "Obs"=c(summary(intervalEstJoint)$n,      NA, NA, NA,NA),
           "LogLik"=c(summary(intervalEstJoint)$loglik[1], NA, NA, NA,NA)
           )[,c(1,2,5)]


##### Prepare results in a table      
      ### put the three regressions in one table
       uniqueRownames<-  unique(c(rownames(table5.Trees), rownames(table5.Fount), rownames(table5.Both), rownames(table5.Joint)))

        table5.0 <- cbind(
        table5.Trees[match(uniqueRownames, rownames(table5.Trees)),],
        table5.Fount[match(uniqueRownames, rownames(table5.Fount)),],
        table5.Both[match(uniqueRownames, rownames(table5.Both))  ,],
        table5.Joint[match(uniqueRownames, rownames(table5.Joint)),]
        )
        rownames(table5.0)<- uniqueRownames
                
        # drop Obs and LogLik because they have nos SE
         table5.1<-table5.0[ !rownames(table5.0)%in%c("Obs", "LogLik"),]
        # make an empty matrix to be filled  
         table5.2<-matrix(NA,ncol=8, nrow=nrow(table5.1)*2)
         # add rownames
            rownames(table5.2)<-  rep(paste("SE.",rownames(table5.1), sep=""), each=2) #rep("SE", times=nrow(table5.2))
            rownames(table5.2)[seq(1, 2*nrow(table5.1), by=2)] <- rownames(table5.1)
         # add coeffient estiamtes
         table5.2[seq(1, 2*nrow(table5.1), by=2),c(1,3,5,7)] <- table5.1[,c(1,4,7,10)]
         # add standard errors in the row below coeffients
         table5.2[seq(2, 2*nrow(table5.1), by=2),c(1,3,5,7)] <- table5.1[,c(2,5,8,11)]
         # add stars
           star<-matrix(NA, nrow=(nrow(table5.1)), ncol=4)
           star[table5.1[,c(3,6,9,12)]<0.1]<-"*"
           star[table5.1[,c(3,6,9,12)]<0.05]<-"**"
           #star10<-matrix(NA, nrow=(nrow(table5.1)), ncol=4)
           #star10[table5.1[,c(3,6,9,12)]<0.1]<-"*"
         table5.2[seq(1, 2*nrow(table5.1), by=2),c(2,4,6,8)] <- star
         #table5.2[seq(1, 2*nrow(table5.1), by=2),c(2,4,6,8)] <- star5
         # add Obs and LogLik 
         table5<-rbind(table5.2,table5.0[rownames(table5.0)%in%c("Obs", "LogLik"),c(1,2,4,5,7,8,10,11)])
         # drop the helper tables
         rm(table5.0, table5.1, table5.2)
        # save as data.frame 
        table5<-as.data.frame(table5)
        # change the order of the variables
        
          table5<-table5[c( 
            "(Intercept)","SE.(Intercept)",
            "leveltrees50","SE.leveltrees50",
            "levelfounverdoppelt","SE.levelfounverdoppelt",
            "scenariofountains","SE.scenariofountains",
            "scenarioboth", "SE.scenarioboth",
            "treeDensityClasses2","SE.treeDensityClasses2",
            "hh_persons2Binary", "SE.hh_persons2Binary",
            "hh_persons3Binary", "SE.hh_persons3Binary",
            "as.numeric(X10_debrief_joint_OthersUtility)","SE.as.numeric(X10_debrief_joint_OthersUtility)",
            "as.numeric(X10_debrief_joint_FavourHeatmeasures)","SE.as.numeric(X10_debrief_joint_FavourHeatmeasures)",
            "genderw","SE.genderw",
            "age","SE.age",
            "pensionyes","SE.pensionyes",                                      
            "universitydegreeYes", "SE.universitydegreeYes",
            "dogOwnyes","SE.dogOwnyes",
            "hh_incom_aequi","SE.hh_incom_aequi",
            "parkpl","SE.parkpl",
            "carone","SE.carone",
            "cartwo or more","SE.cartwo or more",                                  
            "online","SE.online",
            "Log(scale)", "SE.Log(scale)",
            "Obs", "LogLik"),]       
